#include <amxmodx>
#include <engine>
#include <fakemeta>
#include <fun>
#include <hamsandwich>
#include <xs>
#include <cstrike>
#include <zombieplague>

#define ENG_NULLENT			-1
#define EV_INT_WEAPONKEY	EV_INT_impulse
#define m24_WEAPONKEY 		810
#define awpcamo_WEAPONKEY 	811
#define m200_WEAPONKEY 		812
#define trg42_WEAPONKEY 		813
#define svd_WEAPONKEY 		814
#define vsk94_WEAPONKEY 		815
#define sl8_WEAPONKEY 		816
#define MAX_PLAYERS  		32
#define IsValidUser(%1) (1 <= %1 <= g_MaxPlayers)

const USE_STOPPED = 0
const OFFSET_ACTIVE_ITEM = 373
const OFFSET_WEAPONOWNER = 41
const OFFSET_LINUX = 5
const OFFSET_LINUX_WEAPONS = 4

#define WEAP_LINUX_XTRA_OFF		4

#define m_fKnown					44
#define m_flNextPrimaryAttack 		46
#define m_flTimeWeaponIdle			48
#define m_iClip					51
#define m_fInReload				54
#define PLAYER_LINUX_XTRA_OFF	5
#define m_flNextAttack				83

#define m24_RELOAD_TIME		3.0
#define awpcamo_RELOAD_TIME	3.0
#define m200_RELOAD_TIME	3.0
#define trg42_RELOAD_TIME		3.0
#define svd_RELOAD_TIME		3.5
#define vsk94_RELOAD_TIME	3.2
#define sl8_RELOAD_TIME		3.3

#define m24_SHOOT1		1
#define m24_SHOOT2		2
#define m24_RELOAD		3
#define m24_DRAW		4
#define awpcamo_SHOOT1	1
#define awpcamo_SHOOT2	2
#define awpcamo_RELOAD	4
#define awpcamo_DRAW	5
#define m200_SHOOT1		1
#define m200_SHOOT2		2
#define m200_RELOAD		4
#define m200_DRAW		5
#define trg42_SHOOT1		1
#define trg42_SHOOT2		2
#define trg42_RELOAD		4
#define trg42_DRAW		5
#define svd_SHOOT1		1
#define svd_SHOOT2		2
#define svd_RELOAD		4
#define svd_DRAW			5
#define vsk94_SHOOT1		1
#define vsk94_SHOOT2		2
#define vsk94_RELOAD		3
#define vsk94_DRAW		4
#define sl8_SHOOT1		1
#define sl8_SHOOT2		2
#define sl8_RELOAD		3
#define sl8_DRAW			4

#define write_coord_f(%1)	engfunc(EngFunc_WriteCoord,%1)

new const Fire_Sounds[][] = { "weapons/m24.wav", "weapons/awp1.wav", "weapons/m200.wav", "weapons/trg42.wav", "weapons/svd.wav", "weapons/vsk94.wav", "weapons/sl8.wav" }

new m24_V_MODEL[64] = "models/zm/v_m24.mdl"
new m24_P_MODEL[64] = "models/zm/p_m24.mdl"
new m24_W_MODEL[64] = "models/zm/w_m24.mdl"

new awpcamo_V_MODEL[64] = "models/zm/v_awpcamo.mdl"
new awpcamo_P_MODEL[64] = "models/zm/p_awpcamo.mdl"
new awpcamo_W_MODEL[64] = "models/zm/w_awpcamo.mdl"

new m200_V_MODEL[64] = "models/zm/v_m200.mdl"
new m200_P_MODEL[64] = "models/zm/p_m200.mdl"
new m200_W_MODEL[64] = "models/zm/w_m200.mdl"

new trg42_V_MODEL[64] = "models/zm/v_trg42.mdl"
new trg42_P_MODEL[64] = "models/zm/p_trg42.mdl"
new trg42_W_MODEL[64] = "models/zm/w_trg42.mdl"

new svd_V_MODEL[64] = "models/zm/v_svd.mdl"
new svd_P_MODEL[64] = "models/zm/p_svd.mdl"
new svd_W_MODEL[64] = "models/zm/w_svd.mdl"

new vsk94_V_MODEL[64] = "models/zm/v_vsk94.mdl"
new vsk94_P_MODEL[64] = "models/zm/p_vsk94.mdl"
new vsk94_W_MODEL[64] = "models/zm/w_vsk94.mdl"

new sl8_V_MODEL[64] = "models/zm/v_sl8.mdl"
new sl8_P_MODEL[64] = "models/zm/p_sl8.mdl"
new sl8_W_MODEL[64] = "models/zm/w_sl8.mdl"

new const GUNSHOT_DECALS[] = { 41, 42, 43, 44, 45 }

new cvar_dmg_m24, cvar_recoil_m24, g_itemid_m24, cvar_clip_m24, cvar_spd_m24, cvar_m24_ammo
new cvar_dmg_awpcamo, cvar_recoil_awpcamo, g_itemid_awpcamo, cvar_clip_awpcamo, cvar_spd_awpcamo, cvar_awpcamo_ammo
new cvar_dmg_m200, cvar_recoil_m200, g_itemid_m200, cvar_clip_m200, cvar_spd_m200, cvar_m200_ammo
new cvar_dmg_trg42, cvar_recoil_trg42, g_itemid_trg42, cvar_clip_trg42, cvar_spd_trg42, cvar_trg42_ammo
new cvar_dmg_svd, cvar_recoil_svd, g_itemid_svd, cvar_clip_svd, cvar_spd_svd, cvar_svd_ammo
new cvar_dmg_vsk94, cvar_recoil_vsk94, g_itemid_vsk94, cvar_clip_vsk94, cvar_spd_vsk94, cvar_vsk94_ammo
new cvar_dmg_sl8, cvar_recoil_sl8, g_itemid_sl8, cvar_clip_sl8, cvar_spd_sl8, cvar_sl8_ammo
new g_orig_event_m24, g_orig_event_awpcamo, g_orig_event_m200, g_orig_event_trg42, g_orig_event_svd, g_orig_event_vsk94, g_orig_event_sl8, g_has_m24[33], g_has_awpcamo[33], g_has_m200[33], g_has_trg42[33], g_has_svd[33], g_has_vsk94[33], g_has_sl8[33], g_m24_TmpClip[33], g_awpcamo_TmpClip[33], g_m200_TmpClip[33], g_trg42_TmpClip[33], g_svd_TmpClip[33], g_vsk94_TmpClip[33], g_sl8_TmpClip[33]
new Float:cl_pushangle[MAX_PLAYERS + 1][3], m_iBlood[2]
new g_MaxPlayers, g_IsInPrimaryAttack, g_clip_ammo[33], oldweap[33]
new gmsgWeaponList

const PRIMARY_WEAPONS_BIT_SUM = 
(1<<CSW_SCOUT)|(1<<CSW_XM1014)|(1<<CSW_MAC10)|(1<<CSW_AUG)|(1<<CSW_UMP45)|(1<<CSW_SG550)|(1<<CSW_GALIL)|(1<<CSW_FAMAS)|(1<<CSW_AWP)|(1<<
CSW_MP5NAVY)|(1<<CSW_M249)|(1<<CSW_M3)|(1<<CSW_M4A1)|(1<<CSW_TMP)|(1<<CSW_G3SG1)|(1<<CSW_SG552)|(1<<CSW_AK47)|(1<<CSW_P90)
new const WEAPONENTNAMES[][] = { "", "weapon_p228", "", "weapon_scout", "weapon_hegrenade", "weapon_xm1014", "weapon_c4", "weapon_mac10",
			"weapon_aug", "weapon_smokegrenade", "weapon_elite", "weapon_fiveseven", "weapon_ump45", "weapon_sg550",
			"weapon_galil", "weapon_famas", "weapon_usp", "weapon_glock18", "weapon_awp", "weapon_mp5navy", "weapon_m249",
			"weapon_m3", "weapon_m4a1", "weapon_tmp", "weapon_g3sg1", "weapon_flashbang", "weapon_deagle", "weapon_sg552",
			"weapon_ak47", "weapon_knife", "weapon_p90" }

public plugin_init()
{
	register_plugin("[ZP] Extra: M24 and AWP Camo and M200 and TRG-42 and SVD and VSK94 and H&K SL8", "1.0", "LARS-DAY[BR]EAKER")
	register_message(get_user_msgid("DeathMsg"), "message_DeathMsg")
	register_event("CurWeapon","CurrentWeapon","be","1=1")
	RegisterHam(Ham_Item_AddToPlayer, "weapon_scout", "fw_m24_AddToPlayer")
	RegisterHam(Ham_Item_AddToPlayer, "weapon_awp", "fw_awpcamo_AddToPlayer")
	RegisterHam(Ham_Item_AddToPlayer, "weapon_awp", "fw_m200_AddToPlayer")
	RegisterHam(Ham_Item_AddToPlayer, "weapon_awp", "fw_trg42_AddToPlayer")
	RegisterHam(Ham_Item_AddToPlayer, "weapon_g3sg1", "fw_svd_AddToPlayer")
	RegisterHam(Ham_Item_AddToPlayer, "weapon_sg550", "fw_vsk94_AddToPlayer")
	RegisterHam(Ham_Item_AddToPlayer, "weapon_sg550", "fw_sl8_AddToPlayer")
	RegisterHam(Ham_Use, "func_tank", "fw_UseStationary_Post", 1)
	RegisterHam(Ham_Use, "func_tankmortar", "fw_UseStationary_Post", 1)
	RegisterHam(Ham_Use, "func_tankrocket", "fw_UseStationary_Post", 1)
	RegisterHam(Ham_Use, "func_tanklaser", "fw_UseStationary_Post", 1)
	for (new i = 1; i < sizeof WEAPONENTNAMES; i++)
	if (WEAPONENTNAMES[i][0]) RegisterHam(Ham_Item_Deploy, WEAPONENTNAMES[i], "fw_Item_Deploy_Post", 1)
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_scout", "fw_m24_PrimaryAttack")
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_awp", "fw_awpcamo_PrimaryAttack")
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_awp", "fw_m200_PrimaryAttack")
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_awp", "fw_trg42_PrimaryAttack")
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_g3sg1", "fw_svd_PrimaryAttack")
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_sg550", "fw_vsk94_PrimaryAttack")
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_sg550", "fw_sl8_PrimaryAttack")
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_scout", "fw_m24_PrimaryAttack_Post", 1)
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_awp", "fw_awpcamo_PrimaryAttack_Post", 1)
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_awp", "fw_m200_PrimaryAttack_Post", 1)
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_awp", "fw_trg42_PrimaryAttack_Post", 1)
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_g3sg1", "fw_svd_PrimaryAttack_Post", 1)
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_sg550", "fw_vsk94_PrimaryAttack_Post", 1)
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_sg550", "fw_sl8_PrimaryAttack_Post", 1)
	RegisterHam(Ham_Item_PostFrame, "weapon_scout", "m24_ItemPostFrame")
	RegisterHam(Ham_Item_PostFrame, "weapon_awp", "awpcamo_ItemPostFrame")
	RegisterHam(Ham_Item_PostFrame, "weapon_awp", "m200_ItemPostFrame")
	RegisterHam(Ham_Item_PostFrame, "weapon_awp", "trg42_ItemPostFrame")
	RegisterHam(Ham_Item_PostFrame, "weapon_g3sg1", "svd_ItemPostFrame")
	RegisterHam(Ham_Item_PostFrame, "weapon_sg550", "vsk94_ItemPostFrame")
	RegisterHam(Ham_Item_PostFrame, "weapon_sg550", "sl8_ItemPostFrame")
	RegisterHam(Ham_Weapon_Reload, "weapon_scout", "m24_Reload")
	RegisterHam(Ham_Weapon_Reload, "weapon_awp", "awpcamo_Reload")
	RegisterHam(Ham_Weapon_Reload, "weapon_awp", "m200_Reload")
	RegisterHam(Ham_Weapon_Reload, "weapon_awp", "trg42_Reload")
	RegisterHam(Ham_Weapon_Reload, "weapon_g3sg1", "svd_Reload")
	RegisterHam(Ham_Weapon_Reload, "weapon_sg550", "vsk94_Reload")
	RegisterHam(Ham_Weapon_Reload, "weapon_sg550", "sl8_Reload")
	RegisterHam(Ham_Weapon_Reload, "weapon_scout", "m24_Reload_Post", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_awp", "awpcamo_Reload_Post", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_awp", "m200_Reload_Post", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_awp", "trg42_Reload_Post", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_g3sg1", "svd_Reload_Post", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_sg550", "vsk94_Reload_Post", 1)
	RegisterHam(Ham_Weapon_Reload, "weapon_sg550", "sl8_Reload_Post", 1)
	RegisterHam(Ham_TakeDamage, "player", "fw_TakeDamage")
	register_forward(FM_SetModel, "fw_SetModel")
	register_forward(FM_UpdateClientData, "fw_UpdateClientData_Post", 1)
	register_forward(FM_PlaybackEvent, "fwPlaybackEvent")
	
	RegisterHam(Ham_TraceAttack, "worldspawn", "fw_TraceAttack", 1)
	RegisterHam(Ham_TraceAttack, "func_breakable", "fw_TraceAttack", 1)
	RegisterHam(Ham_TraceAttack, "func_wall", "fw_TraceAttack", 1)
	RegisterHam(Ham_TraceAttack, "func_door", "fw_TraceAttack", 1)
	RegisterHam(Ham_TraceAttack, "func_door_rotating", "fw_TraceAttack", 1)
	RegisterHam(Ham_TraceAttack, "func_plat", "fw_TraceAttack", 1)
	RegisterHam(Ham_TraceAttack, "func_rotating", "fw_TraceAttack", 1)
	gmsgWeaponList = get_user_msgid("WeaponList")

	cvar_dmg_m24 = register_cvar("zp_m24_dmg", "1.523")
	cvar_recoil_m24 = register_cvar("zp_m24_recoil", "1.0")
	cvar_clip_m24 = register_cvar("zp_m24_clip", "10")
	cvar_spd_m24 = register_cvar("zp_m24_spd", "1.045")
	cvar_m24_ammo = register_cvar("zp_m24_ammo", "180")

	cvar_dmg_awpcamo = register_cvar("zp_awpcamo_dmg", "1.0")
	cvar_recoil_awpcamo = register_cvar("zp_awpcamo_recoil", "1.0")
	cvar_clip_awpcamo = register_cvar("zp_awpcamo_clip", "10")
	cvar_spd_awpcamo = register_cvar("zp_awpcamo_spd", "1.0")
	cvar_awpcamo_ammo = register_cvar("zp_awpcamo_ammo", "90")

	cvar_dmg_m200 = register_cvar("zp_m200_dmg", "1.0")
	cvar_recoil_m200 = register_cvar("zp_m200_recoil", "0.95")
	cvar_clip_m200 = register_cvar("zp_m200_clip", "10")
	cvar_spd_m200 = register_cvar("zp_m200_spd", "1.0")
	cvar_m200_ammo = register_cvar("zp_m200_ammo", "90")

	cvar_dmg_trg42 = register_cvar("zp_trg42_dmg", "1.0")
	cvar_recoil_trg42 = register_cvar("zp_trg42_recoil", "0.94")
	cvar_clip_trg42 = register_cvar("zp_trg42_clip", "10")
	cvar_spd_trg42 = register_cvar("zp_trg42_spd", "1.0")
	cvar_trg42_ammo = register_cvar("zp_trg42_ammo", "90")

	cvar_dmg_svd = register_cvar("zp_svd_dmg", "1.37")
	cvar_recoil_svd = register_cvar("zp_svd_recoil", "3.54")
	cvar_clip_svd = register_cvar("zp_svd_clip", "10")
	cvar_spd_svd = register_cvar("zp_svd_spd", "1.6")
	cvar_svd_ammo = register_cvar("zp_svd_ammo", "180")

	cvar_dmg_vsk94 = register_cvar("zp_vsk94_dmg", "1.21")
	cvar_recoil_vsk94 = register_cvar("zp_vsk94_recoil", "1.03")
	cvar_clip_vsk94 = register_cvar("zp_vsk94_clip", "20")
	cvar_spd_vsk94 = register_cvar("zp_vsk94_spd", "0.7")
	cvar_vsk94_ammo = register_cvar("zp_vsk94_ammo", "200")

	cvar_dmg_sl8 = register_cvar("zp_sl8_dmg", "0.885")
	cvar_recoil_sl8 = register_cvar("zp_sl8_recoil", "1.05")
	cvar_clip_sl8 = register_cvar("zp_sl8_clip", "20")
	cvar_spd_sl8 = register_cvar("zp_sl8_spd", "0.98")
	cvar_sl8_ammo = register_cvar("zp_sl8_ammo", "180")
	
	g_itemid_vsk94 = zp_register_extra_item("[Sniper Rifle] \rVSK94", 12, ZP_TEAM_HUMAN)
	g_itemid_svd = zp_register_extra_item("[Sniper Rifle] \rSVD", 14, ZP_TEAM_HUMAN)
	g_itemid_m24 = zp_register_extra_item("[Sniper Rifle] \rM24", 15, ZP_TEAM_HUMAN)
	g_itemid_awpcamo = zp_register_extra_item("[Sniper Rifle] \rAWP Camo", 17, ZP_TEAM_HUMAN)
	g_itemid_m200 = zp_register_extra_item("[Sniper Rifle] \rChey-Tac M200", 17, ZP_TEAM_HUMAN)
	g_itemid_trg42 = zp_register_extra_item("[Sniper Rifle] \rTRG-42", 17, ZP_TEAM_HUMAN)
	g_itemid_sl8 = zp_register_extra_item("[Sniper Rifle] \rH&K SL8", 15, ZP_TEAM_HUMAN)
	g_MaxPlayers = get_maxplayers()
}

public plugin_precache()
{
	precache_model(m24_V_MODEL)
	precache_model(m24_P_MODEL)
	precache_model(m24_W_MODEL)
	precache_model(awpcamo_V_MODEL)
	precache_model(awpcamo_P_MODEL)
	precache_model(awpcamo_W_MODEL)
	precache_model(m200_V_MODEL)
	precache_model(m200_P_MODEL)
	precache_model(m200_W_MODEL)
	precache_model(trg42_V_MODEL)
	precache_model(trg42_P_MODEL)
	precache_model(trg42_W_MODEL)
	precache_model(svd_V_MODEL)
	precache_model(svd_P_MODEL)
	precache_model(svd_W_MODEL)
	precache_model(vsk94_V_MODEL)
	precache_model(vsk94_P_MODEL)
	precache_model(vsk94_W_MODEL)
	precache_model(sl8_V_MODEL)
	precache_model(sl8_P_MODEL)
	precache_model(sl8_W_MODEL)
	for(new i = 0; i < sizeof Fire_Sounds; i++)
	precache_sound(Fire_Sounds[i])	
	precache_sound("weapons/m24_clipin.wav")
	precache_sound("weapons/m24_clipout.wav")
	precache_sound("weapons/m24_foley1.wav")
	precache_sound("weapons/m24_foley2.wav")
	precache_sound("weapons/m24_draw.wav")
	precache_sound("weapons/m200_clipin.wav")
	precache_sound("weapons/m200_clipout.wav")
	precache_sound("weapons/m200_foley1.wav")
	precache_sound("weapons/m200_foley2.wav")
	precache_sound("weapons/trg_clipin.wav")
	precache_sound("weapons/trg_clipout.wav")
	precache_sound("weapons/trg_foley1.wav")
	precache_sound("weapons/trg_foley2.wav")
	precache_sound("weapons/trg_foley3.wav")
	precache_sound("weapons/svd_clipin.wav")
	precache_sound("weapons/svd_clipon.wav")
	precache_sound("weapons/svd_clipout.wav")
	precache_sound("weapons/svd_draw.wav")
	precache_sound("weapons/vsk_clipin.wav")
	precache_sound("weapons/vsk_clipout.wav")
	precache_sound("weapons/vsk_draw.wav")
	precache_sound("weapons/sl8_clipin.wav")
	precache_sound("weapons/sl8_clipout.wav")
	precache_sound("weapons/sl8_boltpull.wav")
	precache_sound("weapons/sl8_draw.wav")
	precache_generic("sprites/weapon_m24_paradoks.txt")
	precache_generic("sprites/weapon_m400_paradoks.txt")
	precache_generic("sprites/weapon_trg42_paradoks.txt")
	precache_generic("sprites/weapon_svd_paradoks.txt")
	precache_generic("sprites/weapon_vsk94_paradoks.txt")
	precache_generic("sprites/weapon_sl8_paradoks.txt")
	precache_generic( "sprites/cso/640hud39.spr" )
	precache_generic( "sprites/cso/640hud32.spr" )
	precache_generic( "sprites/cso/640hud29.spr" )
	precache_generic( "sprites/cso/640hud25.spr" )
	precache_generic( "sprites/cso/640hud34.spr" )
	precache_generic( "sprites/640hud7.spr" )
	
	register_clcmd("weapon_m24_paradoks", "Hook_Select")
	register_clcmd("weapon_m400_paradoks", "Hook_Select2")
	register_clcmd("weapon_tgr42_paradoks", "Hook_Select3")
	register_clcmd("weapon_svd_paradoks", "Hook_Select4")
	register_clcmd("weapon_vsk94_paradoks", "Hook_Select5")
	register_clcmd("weapon_sl8_paradoks", "Hook_Select6")
	m_iBlood[0] = precache_model("sprites/blood.spr")
	m_iBlood[1] = precache_model("sprites/bloodspray.spr")

	register_forward(FM_PrecacheEvent, "fwPrecacheEvent_Post", 1)
}

public Sprite(id)
{
    if(g_has_m24[id])
	{
    message_begin(MSG_ONE, gmsgWeaponList, {0,0,0}, id)
    write_string("weapon_m24_paradoks")
    write_byte(2)
    write_byte(90)
    write_byte(-1)
    write_byte(-1)
    write_byte(0)
    write_byte(9)
    write_byte(3)
    write_byte(0)
    message_end()
	}

}

public Sprite1(id)
{
    if(!g_has_m24[id] == true)
	{
    message_begin(MSG_ONE, gmsgWeaponList, {0,0,0}, id)
    write_string("weapon_scout")
    write_byte(2)
    write_byte(90)
    write_byte(-1)
    write_byte(-1)
    write_byte(0)
    write_byte(9)
    write_byte(3)
    write_byte(0)
    message_end()
	}

}
public Sprite2(id)
{
    if(g_has_m200[id])
    {
    message_begin(MSG_ONE, gmsgWeaponList, {0,0,0}, id)
    write_string("weapon_m400_paradoks")
    write_byte(1)
    write_byte(30)
    write_byte(-1)
    write_byte(-1)
    write_byte(0)
    write_byte(2)
    write_byte(18)
    write_byte(0)
    message_end()
	}

}

public Sprite3(id)
{
    if(!g_has_m200[id] == true)
	{
    message_begin(MSG_ONE, gmsgWeaponList, {0,0,0}, id)
    write_string("weapon_awp")
    write_byte(1)
    write_byte(30)
    write_byte(-1)
    write_byte(-1)
    write_byte(0)
    write_byte(2)
    write_byte(18)
    write_byte(0)
    message_end()
	}

}
public Sprite4(id)
{
    if(g_has_trg42[id])
    {
    message_begin(MSG_ONE, gmsgWeaponList, {0,0,0}, id)
    write_string("weapon_trg42_paradoks")
    write_byte(1)
    write_byte(30)
    write_byte(-1)
    write_byte(-1)
    write_byte(0)
    write_byte(2)
    write_byte(18)
    write_byte(0)
    message_end()
	}

}

public Sprite5(id)
{
    if(!g_has_trg42[id] == true)
	{
    message_begin(MSG_ONE, gmsgWeaponList, {0,0,0}, id)
    write_string("weapon_awp")
    write_byte(1)
    write_byte(30)
    write_byte(-1)
    write_byte(-1)
    write_byte(0)
    write_byte(2)
    write_byte(18)
    write_byte(0)
    message_end()
	}

}
public Sprite6(id)
{
    if(g_has_svd[id])
    {
    message_begin(MSG_ONE, gmsgWeaponList, {0,0,0}, id)
    write_string("weapon_svd_paradoks")
    write_byte(2)
    write_byte(90)
    write_byte(-1)
    write_byte(-1)
    write_byte(0)
    write_byte(3)
    write_byte(24)
    write_byte(0)
    message_end()
	}

}

public Sprite7(id)
{
    if(!g_has_svd[id] == true)
	{
    message_begin(MSG_ONE, gmsgWeaponList, {0,0,0}, id)
    write_string("weapon_g3sg1")
    write_byte(2)
    write_byte(90)
    write_byte(-1)
    write_byte(-1)
    write_byte(0)
    write_byte(3)
    write_byte(24)
    write_byte(0)
    message_end()
	}

}
public Sprite8(id)
{
    if(g_has_vsk94[id])
    {
    message_begin(MSG_ONE, gmsgWeaponList, {0,0,0}, id)
    write_string("weapon_vsk94_paradoks")
    write_byte(4)
    write_byte(90)
    write_byte(-1)
    write_byte(-1)
    write_byte(0)
    write_byte(16)
    write_byte(13)
    write_byte(0)
    message_end()
	}

}

public Sprite9(id)
{
    if(!g_has_vsk94[id] == true)
	{
    message_begin(MSG_ONE, gmsgWeaponList, {0,0,0}, id)
    write_string("weapon_sg550")
    write_byte(4)
    write_byte(90)
    write_byte(-1)
    write_byte(-1)
    write_byte(0)
    write_byte(16)
    write_byte(13)
    write_byte(0)
    message_end()
	}

}
public Sprite10(id)
{
    if(g_has_sl8[id])
    {
    message_begin(MSG_ONE, gmsgWeaponList, {0,0,0}, id)
    write_string("weapon_sl8_paradoks")
    write_byte(4)
    write_byte(90)
    write_byte(-1)
    write_byte(-1)
    write_byte(0)
    write_byte(16)
    write_byte(13)
    write_byte(0)
    message_end()
	}

}

public Sprite11(id)
{
    if(!g_has_sl8[id] == true)
	{
    message_begin(MSG_ONE, gmsgWeaponList, {0,0,0}, id)
    write_string("weapon_sg550")
    write_byte(4)
    write_byte(90)
    write_byte(-1)
    write_byte(-1)
    write_byte(0)
    write_byte(16)
    write_byte(13)
    write_byte(0)
    message_end()
	}

}
public Hook_Select(id)
{
    engclient_cmd(id, "weapon_scout")
    return PLUGIN_HANDLED
}
public Hook_Select2(id)
{
    engclient_cmd(id, "weapon_awp")
    return PLUGIN_HANDLED
}
public Hook_Select3(id)
{
    engclient_cmd(id, "weapon_awp")
    return PLUGIN_HANDLED
}
public Hook_Select4(id)
{
    engclient_cmd(id, "weapon_g3sg1")
    return PLUGIN_HANDLED
}
public Hook_Select5(id)
{
    engclient_cmd(id, "weapon_sg550")
    return PLUGIN_HANDLED
}
public Hook_Select6(id)
{
    engclient_cmd(id, "weapon_sg550")
    return PLUGIN_HANDLED
}

public fw_TraceAttack(iEnt, iAttacker, Float:flDamage, Float:fDir[3], ptr, iDamageType)
{
	if(!is_user_alive(iAttacker))
		return

	new g_currentweapon = get_user_weapon(iAttacker)

	if(g_currentweapon != CSW_SCOUT && g_currentweapon != CSW_AWP && g_currentweapon != CSW_G3SG1 && g_currentweapon != CSW_SG550) return
	
	if(!g_has_m24[iAttacker] && !g_has_awpcamo[iAttacker] && !g_has_m200[iAttacker] && !g_has_trg42[iAttacker] && !g_has_svd[iAttacker] && !g_has_vsk94[iAttacker] && !g_has_sl8[iAttacker]) return

	static Float:flEnd[3]
	get_tr2(ptr, TR_vecEndPos, flEnd)
	
	if(iEnt)
	{
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_DECAL)
		write_coord_f(flEnd[0])
		write_coord_f(flEnd[1])
		write_coord_f(flEnd[2])
		write_byte(GUNSHOT_DECALS[random_num (0, sizeof GUNSHOT_DECALS -1)])
		write_short(iEnt)
		message_end()
	}
	else
	{
		message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
		write_byte(TE_WORLDDECAL)
		write_coord_f(flEnd[0])
		write_coord_f(flEnd[1])
		write_coord_f(flEnd[2])
		write_byte(GUNSHOT_DECALS[random_num (0, sizeof GUNSHOT_DECALS -1)])
		message_end()
	}
	message_begin(MSG_BROADCAST, SVC_TEMPENTITY)
	write_byte(TE_GUNSHOTDECAL)
	write_coord_f(flEnd[0])
	write_coord_f(flEnd[1])
	write_coord_f(flEnd[2])
	write_short(iAttacker)
	write_byte(GUNSHOT_DECALS[random_num (0, sizeof GUNSHOT_DECALS -1)])
	message_end()
}

public fwPrecacheEvent_Post(type, const name[])
{
	if (equal("events/scout.sc", name))
	{
		g_orig_event_m24 = get_orig_retval()
		return FMRES_HANDLED
	}
	else if (equal("events/awp.sc", name))
	{
		g_orig_event_awpcamo = get_orig_retval()
		return FMRES_HANDLED
	}
	else if (equal("events/awp.sc", name))
	{
		g_orig_event_m200 = get_orig_retval()
		return FMRES_HANDLED
	}
	else if (equal("events/awp.sc", name))
	{
		g_orig_event_trg42 = get_orig_retval()
		return FMRES_HANDLED
	}
	else if (equal("events/g3sg1.sc", name))
	{
		g_orig_event_svd = get_orig_retval()
		return FMRES_HANDLED
	}
	else if (equal("events/sg550.sc", name))
	{
		g_orig_event_vsk94 = get_orig_retval()
		return FMRES_HANDLED
	}
	else if (equal("events/sg550.sc", name))
	{
		g_orig_event_sl8 = get_orig_retval()
		return FMRES_HANDLED
	}
	return FMRES_IGNORED
}

public client_connect(id)
{
	g_has_m24[id] = false
	g_has_awpcamo[id] = false
	g_has_m200[id] = false
	g_has_trg42[id] = false
	g_has_svd[id] = false
	g_has_vsk94[id] = false
	g_has_sl8[id] = false
}

public client_disconnect(id)
{
	g_has_m24[id] = false
	g_has_awpcamo[id] = false
	g_has_m200[id] = false
	g_has_trg42[id] = false
	g_has_svd[id] = false
	g_has_vsk94[id] = false
	g_has_sl8[id] = false
}

public zp_user_infected_post(id)
{
	if (zp_get_user_zombie(id))
	{
		g_has_m24[id] = false
		g_has_awpcamo[id] = false
		g_has_m200[id] = false
		g_has_trg42[id] = false
		g_has_svd[id] = false
		g_has_vsk94[id] = false
		g_has_sl8[id] = false
	}
}

public fw_SetModel(entity, model[])
{
	if(!is_valid_ent(entity))
		return FMRES_IGNORED
	
	static szClassName[33]
	entity_get_string(entity, EV_SZ_classname, szClassName, charsmax(szClassName))
		
	if(!equal(szClassName, "weaponbox"))
		return FMRES_IGNORED
	
	static iOwner
	
	iOwner = entity_get_edict(entity, EV_ENT_owner)
	
	if(equal(model, "models/w_scout.mdl"))
	{
		static iStoredAugID
		
		iStoredAugID = find_ent_by_owner(ENG_NULLENT, "weapon_scout", entity)
	
		if(!is_valid_ent(iStoredAugID))
			return FMRES_IGNORED
	
		if(g_has_m24[iOwner])
		{
			entity_set_int(iStoredAugID, EV_INT_WEAPONKEY, m24_WEAPONKEY)
			
			g_has_m24[iOwner] = false
			
			entity_set_model(entity, m24_W_MODEL)
			
			return FMRES_SUPERCEDE
		}
	}
	else if(equal(model, "models/w_awp.mdl"))
	{
		static iStoredAugID
		
		iStoredAugID = find_ent_by_owner(ENG_NULLENT, "weapon_awp", entity)
	
		if(!is_valid_ent(iStoredAugID))
			return FMRES_IGNORED
	
		if(g_has_awpcamo[iOwner])
		{
			entity_set_int(iStoredAugID, EV_INT_WEAPONKEY, awpcamo_WEAPONKEY)
			
			g_has_awpcamo[iOwner] = false
			
			entity_set_model(entity, awpcamo_W_MODEL)
			
			return FMRES_SUPERCEDE
		}
		else if(g_has_m200[iOwner])
		{
			entity_set_int(iStoredAugID, EV_INT_WEAPONKEY, m200_WEAPONKEY)
			
			g_has_m200[iOwner] = false
			
			entity_set_model(entity, m200_W_MODEL)
			
			return FMRES_SUPERCEDE
		}
		else if(g_has_trg42[iOwner])
		{
			entity_set_int(iStoredAugID, EV_INT_WEAPONKEY, trg42_WEAPONKEY)
			
			g_has_trg42[iOwner] = false
			
			entity_set_model(entity, trg42_W_MODEL)
			
			return FMRES_SUPERCEDE
		}
	}
	else if(equal(model, "models/w_g3sg1.mdl"))
	{
		static iStoredAugID
		
		iStoredAugID = find_ent_by_owner(ENG_NULLENT, "weapon_g3sg1", entity)
	
		if(!is_valid_ent(iStoredAugID))
			return FMRES_IGNORED
	
		if(g_has_svd[iOwner])
		{
			entity_set_int(iStoredAugID, EV_INT_WEAPONKEY, svd_WEAPONKEY)
			
			g_has_svd[iOwner] = false
			
			entity_set_model(entity, svd_W_MODEL)
			
			return FMRES_SUPERCEDE
		}
	}
	else if(equal(model, "models/w_sg550.mdl"))
	{
		static iStoredAugID
		
		iStoredAugID = find_ent_by_owner(ENG_NULLENT, "weapon_sg550", entity)
	
		if(!is_valid_ent(iStoredAugID))
			return FMRES_IGNORED
	
		if(g_has_vsk94[iOwner])
		{
			entity_set_int(iStoredAugID, EV_INT_WEAPONKEY, vsk94_WEAPONKEY)
			
			g_has_vsk94[iOwner] = false
			
			entity_set_model(entity, vsk94_W_MODEL)
			
			return FMRES_SUPERCEDE
		}
		else if(g_has_sl8[iOwner])
		{
			entity_set_int(iStoredAugID, EV_INT_WEAPONKEY, sl8_WEAPONKEY)
			
			g_has_sl8[iOwner] = false
			
			entity_set_model(entity, sl8_W_MODEL)
			
			return FMRES_SUPERCEDE
		}
	}
	return FMRES_IGNORED
}

public zp_extra_item_selected(id, itemid)
{
	if(itemid == g_itemid_m24)
	{
		drop_weapons(id, 1)
		new iWep2 = give_item(id,"weapon_scout")
		if( iWep2 > 0 )
		{
			cs_set_weapon_ammo(iWep2, get_pcvar_num(cvar_clip_m24))
			cs_set_user_bpammo (id, CSW_SCOUT, get_pcvar_num(cvar_m24_ammo))	
			UTIL_PlayWeaponAnimation(id, m24_DRAW)
			set_pdata_float(id, m_flNextAttack, 1.0, PLAYER_LINUX_XTRA_OFF)
		}
		g_has_m24[id] = true
		Sprite(id)
	}
	else if(itemid == g_itemid_awpcamo)
	{
		drop_weapons(id, 1)
		new iWep2 = give_item(id,"weapon_awp")
		if( iWep2 > 0 )
		{
			cs_set_weapon_ammo(iWep2, get_pcvar_num(cvar_clip_awpcamo))
			cs_set_user_bpammo (id, CSW_AWP, get_pcvar_num(cvar_awpcamo_ammo))	
			UTIL_PlayWeaponAnimation(id, awpcamo_DRAW)
			set_pdata_float(id, m_flNextAttack, 1.0, PLAYER_LINUX_XTRA_OFF)
		}
		g_has_awpcamo[id] = true
	}
	else if(itemid == g_itemid_m200)
	{
		drop_weapons(id, 1)
		new iWep2 = give_item(id,"weapon_awp")
		if( iWep2 > 0 )
		{
			cs_set_weapon_ammo(iWep2, get_pcvar_num(cvar_clip_m200))
			cs_set_user_bpammo (id, CSW_AWP, get_pcvar_num(cvar_m200_ammo))	
			UTIL_PlayWeaponAnimation(id, m200_DRAW)
			set_pdata_float(id, m_flNextAttack, 1.0, PLAYER_LINUX_XTRA_OFF)
		}
		g_has_m200[id] = true
		Sprite2(id)
	}
	else if(itemid == g_itemid_trg42)
	{
		drop_weapons(id, 1)
		new iWep2 = give_item(id,"weapon_awp")
		if( iWep2 > 0 )
		{
			cs_set_weapon_ammo(iWep2, get_pcvar_num(cvar_clip_trg42))
			cs_set_user_bpammo (id, CSW_AWP, get_pcvar_num(cvar_trg42_ammo))	
			UTIL_PlayWeaponAnimation(id, trg42_DRAW)
			set_pdata_float(id, m_flNextAttack, 1.0, PLAYER_LINUX_XTRA_OFF)
		}
		g_has_trg42[id] = true
		Sprite4(id)
	}
	else if(itemid == g_itemid_svd)
	{
		drop_weapons(id, 1)
		new iWep2 = give_item(id,"weapon_g3sg1")
		if( iWep2 > 0 )
		{
			cs_set_weapon_ammo(iWep2, get_pcvar_num(cvar_clip_svd))
			cs_set_user_bpammo (id, CSW_G3SG1, get_pcvar_num(cvar_svd_ammo))	
			UTIL_PlayWeaponAnimation(id, svd_DRAW)
			set_pdata_float(id, m_flNextAttack, 1.0, PLAYER_LINUX_XTRA_OFF)
		}
		g_has_svd[id] = true
		Sprite6(id)
	}
	else if(itemid == g_itemid_vsk94)
	{
		drop_weapons(id, 1)
		new iWep2 = give_item(id,"weapon_sg550")
		if( iWep2 > 0 )
		{
			cs_set_weapon_ammo(iWep2, get_pcvar_num(cvar_clip_vsk94))
			cs_set_user_bpammo (id, CSW_SG550, get_pcvar_num(cvar_vsk94_ammo))	
			UTIL_PlayWeaponAnimation(id, vsk94_DRAW)
			set_pdata_float(id, m_flNextAttack, 1.0, PLAYER_LINUX_XTRA_OFF)
		}
		g_has_vsk94[id] = true
		Sprite8(id)
	}
	else if(itemid == g_itemid_sl8)
	{
		drop_weapons(id, 1)
		new iWep2 = give_item(id,"weapon_sg550")
		if( iWep2 > 0 )
		{
			cs_set_weapon_ammo(iWep2, get_pcvar_num(cvar_clip_sl8))
			cs_set_user_bpammo (id, CSW_SG550, get_pcvar_num(cvar_sl8_ammo))	
			UTIL_PlayWeaponAnimation(id, sl8_DRAW)
			set_pdata_float(id, m_flNextAttack, 1.0, PLAYER_LINUX_XTRA_OFF)
		}
		g_has_sl8[id] = true
		Sprite10(id)
	}
}

public fw_m24_AddToPlayer(m24, id)
{
	if(!is_valid_ent(m24) || !is_user_connected(id))
		return HAM_IGNORED
	
	if(entity_get_int(m24, EV_INT_WEAPONKEY) == m24_WEAPONKEY)
	{
		g_has_m24[id] = true
		Sprite(id)
		
		entity_set_int(m24, EV_INT_WEAPONKEY, 0)
		
		return HAM_HANDLED
	}
	return HAM_IGNORED
}

public fw_awpcamo_AddToPlayer(awpcamo, id)
{
	if(!is_valid_ent(awpcamo) || !is_user_connected(id))
		return HAM_IGNORED
	
	if(entity_get_int(awpcamo, EV_INT_WEAPONKEY) == awpcamo_WEAPONKEY)
	{
		g_has_awpcamo[id] = true
		
		entity_set_int(awpcamo, EV_INT_WEAPONKEY, 0)
		
		return HAM_HANDLED
	}
	return HAM_IGNORED
}

public fw_m200_AddToPlayer(m200, id)
{
	if(!is_valid_ent(m200) || !is_user_connected(id))
		return HAM_IGNORED
	
	if(entity_get_int(m200, EV_INT_WEAPONKEY) == m200_WEAPONKEY)
	{
		g_has_m200[id] = true
		Sprite2(id)
		
		entity_set_int(m200, EV_INT_WEAPONKEY, 0)
		
		return HAM_HANDLED
	}
	return HAM_IGNORED
}

public fw_trg42_AddToPlayer(trg42, id)
{
	if(!is_valid_ent(trg42) || !is_user_connected(id))
		return HAM_IGNORED
	
	if(entity_get_int(trg42, EV_INT_WEAPONKEY) == trg42_WEAPONKEY)
	{
		g_has_trg42[id] = true
		Sprite4(id)
		
		entity_set_int(trg42, EV_INT_WEAPONKEY, 0)
		
		return HAM_HANDLED
	}
	return HAM_IGNORED
}

public fw_svd_AddToPlayer(svd, id)
{
	if(!is_valid_ent(svd) || !is_user_connected(id))
		return HAM_IGNORED
	
	if(entity_get_int(svd, EV_INT_WEAPONKEY) == svd_WEAPONKEY)
	{
		g_has_svd[id] = true
		Sprite6(id)
		
		entity_set_int(svd, EV_INT_WEAPONKEY, 0)
		
		return HAM_HANDLED
	}
	return HAM_IGNORED
}

public fw_vsk94_AddToPlayer(vsk94, id)
{
	if(!is_valid_ent(vsk94) || !is_user_connected(id))
		return HAM_IGNORED
	
	if(entity_get_int(vsk94, EV_INT_WEAPONKEY) == vsk94_WEAPONKEY)
	{
		g_has_vsk94[id] = true
		Sprite8(id)
		
		entity_set_int(vsk94, EV_INT_WEAPONKEY, 0)
		
		return HAM_HANDLED
	}
	return HAM_IGNORED
}

public fw_sl8_AddToPlayer(sl8, id)
{
	if(!is_valid_ent(sl8) || !is_user_connected(id))
		return HAM_IGNORED
	
	if(entity_get_int(sl8, EV_INT_WEAPONKEY) == sl8_WEAPONKEY)
	{
		g_has_sl8[id] = true
		Sprite10(id)
		
		entity_set_int(sl8, EV_INT_WEAPONKEY, 0)
		
		return HAM_HANDLED
	}
	return HAM_IGNORED
}

public fw_UseStationary_Post(entity, caller, activator, use_type)
{
	if (use_type == USE_STOPPED && is_user_connected(caller))
		replace_weapon_models(caller, get_user_weapon(caller))
}

public fw_Item_Deploy_Post(weapon_ent)
{
	static owner
	owner = fm_cs_get_weapon_ent_owner(weapon_ent)
	
	static weaponid
	weaponid = cs_get_weapon_id(weapon_ent)
	
	replace_weapon_models(owner, weaponid)
}

public CurrentWeapon(id)
{
     replace_weapon_models(id, read_data(2))

     static weapon[32],Ent
     get_weaponname(read_data(2),weapon,31)
     Ent = find_ent_by_owner(-1,weapon,id)
     if(Ent)
     {
          static Float:Delay, Float:M_Delay
	  static Float:iSpeed
	  iSpeed = 0.0
 	  if(read_data(2) == CSW_SCOUT && g_has_m24[id])
		iSpeed = get_pcvar_float(cvar_spd_m24)
     	  else if(read_data(2) == CSW_AWP)
	  {
		if(g_has_awpcamo[id])
          		iSpeed = get_pcvar_float(cvar_spd_awpcamo)
		else if(g_has_m200[id])
          		iSpeed = get_pcvar_float(cvar_spd_m200)
		else if(g_has_trg42[id])
          		iSpeed = get_pcvar_float(cvar_spd_trg42)
	  }
	  else if(read_data(2) == CSW_G3SG1 && g_has_svd[id])
          	iSpeed = get_pcvar_float(cvar_spd_svd)
     	  else if(read_data(2) == CSW_SG550)
	  {
		if(g_has_vsk94[id])
          		iSpeed = get_pcvar_float(cvar_spd_vsk94)
		else if(g_has_sl8[id])
          		iSpeed = get_pcvar_float(cvar_spd_sl8)
	  }
          Delay = get_pdata_float( Ent, 46, 4) * iSpeed
 	  M_Delay = get_pdata_float( Ent, 47, 4) * iSpeed
          if (Delay > 0.0)
          {
               set_pdata_float(Ent, 46, Delay, 4)
	       set_pdata_float(Ent, 47, M_Delay, 4)
          }
     }
}

replace_weapon_models(id, weaponid)
{
	switch (weaponid)
	{
		case CSW_SCOUT:
		{
			if (zp_get_user_zombie(id) || zp_get_user_survivor(id))
				return
			
			if(g_has_m24[id])
			{
				set_pev(id, pev_viewmodel2, m24_V_MODEL)
				set_pev(id, pev_weaponmodel2, m24_P_MODEL)
				if(oldweap[id] != CSW_SCOUT) 
				{
					UTIL_PlayWeaponAnimation(id, m24_DRAW)
					set_pdata_float(id, m_flNextAttack, 1.0, PLAYER_LINUX_XTRA_OFF)
				}
			}
		}
		case CSW_AWP:
		{
			if (zp_get_user_zombie(id) || zp_get_user_survivor(id))
				return
			
			if(g_has_awpcamo[id])
			{
				set_pev(id, pev_viewmodel2, awpcamo_V_MODEL)
				set_pev(id, pev_weaponmodel2, awpcamo_P_MODEL)
				if(oldweap[id] != CSW_AWP) 
				{
					UTIL_PlayWeaponAnimation(id, awpcamo_DRAW)
					set_pdata_float(id, m_flNextAttack, 1.0, PLAYER_LINUX_XTRA_OFF)
				}
			}
			else if(g_has_m200[id])
			{
				set_pev(id, pev_viewmodel2, m200_V_MODEL)
				set_pev(id, pev_weaponmodel2, m200_P_MODEL)
				if(oldweap[id] != CSW_AWP) 
				{
					UTIL_PlayWeaponAnimation(id, m200_DRAW)
					set_pdata_float(id, m_flNextAttack, 1.0, PLAYER_LINUX_XTRA_OFF)
				}
			}
			else if(g_has_trg42[id])
			{
				set_pev(id, pev_viewmodel2, trg42_V_MODEL)
				set_pev(id, pev_weaponmodel2, trg42_P_MODEL)
				if(oldweap[id] != CSW_AWP) 
				{
					UTIL_PlayWeaponAnimation(id, trg42_DRAW)
					set_pdata_float(id, m_flNextAttack, 1.0, PLAYER_LINUX_XTRA_OFF)
				}
			}
		}
		case CSW_G3SG1:
		{
			if (zp_get_user_zombie(id) || zp_get_user_survivor(id))
				return
			
			if(g_has_svd[id])
			{
				set_pev(id, pev_viewmodel2, svd_V_MODEL)
				set_pev(id, pev_weaponmodel2, svd_P_MODEL)
				if(oldweap[id] != CSW_G3SG1) 
				{
					UTIL_PlayWeaponAnimation(id, svd_DRAW)
					set_pdata_float(id, m_flNextAttack, 1.0, PLAYER_LINUX_XTRA_OFF)
				}
			}
		}
		case CSW_SG550:
		{
			if (zp_get_user_zombie(id) || zp_get_user_survivor(id))
				return
			
			if(g_has_vsk94[id])
			{
				set_pev(id, pev_viewmodel2, vsk94_V_MODEL)
				set_pev(id, pev_weaponmodel2, vsk94_P_MODEL)
				if(oldweap[id] != CSW_SG550) 
				{
					UTIL_PlayWeaponAnimation(id, vsk94_DRAW)
					set_pdata_float(id, m_flNextAttack, 1.0, PLAYER_LINUX_XTRA_OFF)
				}
			}
			else if(g_has_sl8[id])
			{
				set_pev(id, pev_viewmodel2, sl8_V_MODEL)
				set_pev(id, pev_weaponmodel2, sl8_P_MODEL)
				if(oldweap[id] != CSW_SG550) 
				{
					UTIL_PlayWeaponAnimation(id, sl8_DRAW)
					set_pdata_float(id, m_flNextAttack, 1.0, PLAYER_LINUX_XTRA_OFF)
				}
			}
		}
	}
	oldweap[id] = weaponid
}

public fw_UpdateClientData_Post(Player, SendWeapons, CD_Handle)
{
	if(!is_user_alive(Player) || 
(get_user_weapon(Player) != CSW_SCOUT && 
get_user_weapon(Player) != CSW_AWP && 
get_user_weapon(Player) != CSW_G3SG1 && 
get_user_weapon(Player) != CSW_SG550) || 
(get_user_weapon(Player) == CSW_SCOUT && !g_has_m24[Player]) || 
(get_user_weapon(Player) == CSW_AWP && !g_has_awpcamo[Player] && !g_has_m200[Player] && !g_has_trg42[Player]) || 
(get_user_weapon(Player) == CSW_G3SG1 && !g_has_svd[Player]) || 
(get_user_weapon(Player) == CSW_SG550 && !g_has_vsk94[Player] && !g_has_sl8[Player]))
	return FMRES_IGNORED
	
	set_cd(CD_Handle, CD_flNextAttack, halflife_time () + 0.001)
	return FMRES_HANDLED
}

public fw_m24_PrimaryAttack(Weapon)
{
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	if (!g_has_m24[Player])
		return
	
	g_IsInPrimaryAttack = 1
	pev(Player,pev_punchangle,cl_pushangle[Player])
	
	g_clip_ammo[Player] = cs_get_weapon_ammo(Weapon)
}

public fw_awpcamo_PrimaryAttack(Weapon)
{
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	if (!g_has_awpcamo[Player])
		return
	
	g_IsInPrimaryAttack = 1
	pev(Player,pev_punchangle,cl_pushangle[Player])
	
	g_clip_ammo[Player] = cs_get_weapon_ammo(Weapon)
}

public fw_m200_PrimaryAttack(Weapon)
{
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	if (!g_has_m200[Player])
		return
	
	g_IsInPrimaryAttack = 1
	pev(Player,pev_punchangle,cl_pushangle[Player])
	
	g_clip_ammo[Player] = cs_get_weapon_ammo(Weapon)
}

public fw_trg42_PrimaryAttack(Weapon)
{
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	if (!g_has_trg42[Player])
		return
	
	g_IsInPrimaryAttack = 1
	pev(Player,pev_punchangle,cl_pushangle[Player])
	
	g_clip_ammo[Player] = cs_get_weapon_ammo(Weapon)
}

public fw_svd_PrimaryAttack(Weapon)
{
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	if (!g_has_svd[Player])
		return
	
	g_IsInPrimaryAttack = 1
	pev(Player,pev_punchangle,cl_pushangle[Player])
	
	g_clip_ammo[Player] = cs_get_weapon_ammo(Weapon)
}

public fw_vsk94_PrimaryAttack(Weapon)
{
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	if (!g_has_vsk94[Player])
		return
	
	g_IsInPrimaryAttack = 1
	pev(Player,pev_punchangle,cl_pushangle[Player])
	
	g_clip_ammo[Player] = cs_get_weapon_ammo(Weapon)
}

public fw_sl8_PrimaryAttack(Weapon)
{
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	if (!g_has_sl8[Player])
		return
	
	g_IsInPrimaryAttack = 1
	pev(Player,pev_punchangle,cl_pushangle[Player])
	
	g_clip_ammo[Player] = cs_get_weapon_ammo(Weapon)
}

public fwPlaybackEvent(flags, invoker, eventid, Float:delay, Float:origin[3], Float:angles[3], Float:fparam1, Float:fparam2, iParam1, iParam2, bParam1, bParam2)
{
	if ((eventid != g_orig_event_m24 && eventid != g_orig_event_awpcamo && eventid != g_orig_event_m200 && eventid != g_orig_event_trg42 && eventid != g_orig_event_svd && eventid != g_orig_event_vsk94 && eventid != g_orig_event_sl8) || !g_IsInPrimaryAttack)
		return FMRES_IGNORED
	if (!(1 <= invoker <= g_MaxPlayers))
    return FMRES_IGNORED

	playback_event(flags | FEV_HOSTONLY, invoker, eventid, delay, origin, angles, fparam1, fparam2, iParam1, iParam2, bParam1, bParam2)
	return FMRES_SUPERCEDE
}

public fw_m24_PrimaryAttack_Post(Weapon)
{
	g_IsInPrimaryAttack = 0
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	new szClip, szAmmo
	get_user_weapon(Player, szClip, szAmmo)
	
	if(!is_user_alive(Player))
		return

	if(g_has_m24[Player])
	{
		if (!g_clip_ammo[Player])
			return

		new Float:push[3]
		pev(Player,pev_punchangle,push)
		xs_vec_sub(push,cl_pushangle[Player],push)
		
		xs_vec_mul_scalar(push,get_pcvar_float(cvar_recoil_m24),push)
		xs_vec_add(push,cl_pushangle[Player],push)
		set_pev(Player,pev_punchangle,push)
		
		emit_sound(Player, CHAN_WEAPON, Fire_Sounds[0], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		UTIL_PlayWeaponAnimation(Player, random_num(m24_SHOOT1, m24_SHOOT2))
	}
}

public fw_awpcamo_PrimaryAttack_Post(Weapon)
{
	g_IsInPrimaryAttack = 0
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	new szClip, szAmmo
	get_user_weapon(Player, szClip, szAmmo)
	
	if(!is_user_alive(Player))
		return

	if(g_has_awpcamo[Player])
	{
		if (!g_clip_ammo[Player])
			return

		new Float:push[3]
		pev(Player,pev_punchangle,push)
		xs_vec_sub(push,cl_pushangle[Player],push)
		
		xs_vec_mul_scalar(push,get_pcvar_float(cvar_recoil_awpcamo),push)
		xs_vec_add(push,cl_pushangle[Player],push)
		set_pev(Player,pev_punchangle,push)
		
		emit_sound(Player, CHAN_WEAPON, Fire_Sounds[1], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		UTIL_PlayWeaponAnimation(Player, random_num(awpcamo_SHOOT1, awpcamo_SHOOT2))
	}
}

public fw_m200_PrimaryAttack_Post(Weapon)
{
	g_IsInPrimaryAttack = 0
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	new szClip, szAmmo
	get_user_weapon(Player, szClip, szAmmo)
	
	if(!is_user_alive(Player))
		return

	if(g_has_m200[Player])
	{
		if (!g_clip_ammo[Player])
			return

		new Float:push[3]
		pev(Player,pev_punchangle,push)
		xs_vec_sub(push,cl_pushangle[Player],push)
		
		xs_vec_mul_scalar(push,get_pcvar_float(cvar_recoil_m200),push)
		xs_vec_add(push,cl_pushangle[Player],push)
		set_pev(Player,pev_punchangle,push)
		
		emit_sound(Player, CHAN_WEAPON, Fire_Sounds[2], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		UTIL_PlayWeaponAnimation(Player, random_num(m200_SHOOT1, m200_SHOOT2))
	}
}

public fw_trg42_PrimaryAttack_Post(Weapon)
{
	g_IsInPrimaryAttack = 0
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	new szClip, szAmmo
	get_user_weapon(Player, szClip, szAmmo)
	
	if(!is_user_alive(Player))
		return

	if(g_has_trg42[Player])
	{
		if (!g_clip_ammo[Player])
			return

		new Float:push[3]
		pev(Player,pev_punchangle,push)
		xs_vec_sub(push,cl_pushangle[Player],push)
		
		xs_vec_mul_scalar(push,get_pcvar_float(cvar_recoil_trg42),push)
		xs_vec_add(push,cl_pushangle[Player],push)
		set_pev(Player,pev_punchangle,push)
		
		emit_sound(Player, CHAN_WEAPON, Fire_Sounds[3], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		UTIL_PlayWeaponAnimation(Player, random_num(trg42_SHOOT1, trg42_SHOOT2))
	}
}

public fw_svd_PrimaryAttack_Post(Weapon)
{
	g_IsInPrimaryAttack = 0
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	new szClip, szAmmo
	get_user_weapon(Player, szClip, szAmmo)
	
	if(!is_user_alive(Player))
		return

	if(g_has_svd[Player])
	{
		if (!g_clip_ammo[Player])
			return

		new Float:push[3]
		pev(Player,pev_punchangle,push)
		xs_vec_sub(push,cl_pushangle[Player],push)
		
		xs_vec_mul_scalar(push,get_pcvar_float(cvar_recoil_svd),push)
		xs_vec_add(push,cl_pushangle[Player],push)
		set_pev(Player,pev_punchangle,push)
		
		emit_sound(Player, CHAN_WEAPON, Fire_Sounds[4], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		UTIL_PlayWeaponAnimation(Player, random_num(svd_SHOOT1, svd_SHOOT2))
	}
}

public fw_vsk94_PrimaryAttack_Post(Weapon)
{
	g_IsInPrimaryAttack = 0
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	new szClip, szAmmo
	get_user_weapon(Player, szClip, szAmmo)
	
	if(!is_user_alive(Player))
		return

	if(g_has_vsk94[Player])
	{
		if (!g_clip_ammo[Player])
			return

		new Float:push[3]
		pev(Player,pev_punchangle,push)
		xs_vec_sub(push,cl_pushangle[Player],push)
		
		xs_vec_mul_scalar(push,get_pcvar_float(cvar_recoil_vsk94),push)
		xs_vec_add(push,cl_pushangle[Player],push)
		set_pev(Player,pev_punchangle,push)
		
		emit_sound(Player, CHAN_WEAPON, Fire_Sounds[5], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		UTIL_PlayWeaponAnimation(Player, random_num(vsk94_SHOOT1, vsk94_SHOOT2))
	}
}

public fw_sl8_PrimaryAttack_Post(Weapon)
{
	g_IsInPrimaryAttack = 0
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	new szClip, szAmmo
	get_user_weapon(Player, szClip, szAmmo)
	
	if(!is_user_alive(Player))
		return

	if(g_has_sl8[Player])
	{
		if (!g_clip_ammo[Player])
			return

		new Float:push[3]
		pev(Player,pev_punchangle,push)
		xs_vec_sub(push,cl_pushangle[Player],push)
		
		xs_vec_mul_scalar(push,get_pcvar_float(cvar_recoil_sl8),push)
		xs_vec_add(push,cl_pushangle[Player],push)
		set_pev(Player,pev_punchangle,push)
		
		emit_sound(Player, CHAN_WEAPON, Fire_Sounds[6], VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		UTIL_PlayWeaponAnimation(Player, random_num(sl8_SHOOT1, sl8_SHOOT2))
	}
}

public fw_TakeDamage(victim, inflictor, attacker, Float:damage)
{
	if (victim != attacker && is_user_connected(attacker))
	{
		if(get_user_weapon(attacker) == CSW_SCOUT)
		{
			if(g_has_m24[attacker])
				SetHamParamFloat(4, damage * get_pcvar_float(cvar_dmg_m24))
		}
		else if(get_user_weapon(attacker) == CSW_AWP)
		{
			if(g_has_awpcamo[attacker])
				SetHamParamFloat(4, damage * get_pcvar_float(cvar_dmg_awpcamo))
			else if(g_has_m200[attacker])
				SetHamParamFloat(4, damage * get_pcvar_float(cvar_dmg_m200))
			else if(g_has_trg42[attacker])
				SetHamParamFloat(4, damage * get_pcvar_float(cvar_dmg_trg42))
		}
		else if(get_user_weapon(attacker) == CSW_G3SG1)
		{
			if(g_has_svd[attacker])
				SetHamParamFloat(4, damage * get_pcvar_float(cvar_dmg_svd))
		}
		else if(get_user_weapon(attacker) == CSW_SG550)
		{
			if(g_has_vsk94[attacker])
				SetHamParamFloat(4, damage * get_pcvar_float(cvar_dmg_vsk94))
			else if(g_has_sl8[attacker])
				SetHamParamFloat(4, damage * get_pcvar_float(cvar_dmg_sl8))
		}
	}
}

public message_DeathMsg(msg_id, msg_dest, id)
{
	static szTruncatedWeapon[33], iAttacker, iVictim
	
	get_msg_arg_string(4, szTruncatedWeapon, charsmax(szTruncatedWeapon))
	
	iAttacker = get_msg_arg_int(1)
	iVictim = get_msg_arg_int(2)
	
	if(!is_user_connected(iAttacker) || iAttacker == iVictim)
		return PLUGIN_CONTINUE
	
	if(equal(szTruncatedWeapon, "scout") && get_user_weapon(iAttacker) == CSW_SCOUT)
	{
		if(g_has_m24[iAttacker])
			set_msg_arg_string(4, "scout")
	}
	else if(equal(szTruncatedWeapon, "awp") && get_user_weapon(iAttacker) == CSW_AWP)
	{
		if(g_has_awpcamo[iAttacker])
			set_msg_arg_string(4, "awp")
		else if(g_has_m200[iAttacker])
			set_msg_arg_string(4, "awp")
		else if(g_has_trg42[iAttacker])
			set_msg_arg_string(4, "awp")
	}
	else if(equal(szTruncatedWeapon, "g3sg1") && get_user_weapon(iAttacker) == CSW_G3SG1)
	{
		if(g_has_svd[iAttacker])
			set_msg_arg_string(4, "g3sg1")
	}
	else if(equal(szTruncatedWeapon, "sg550") && get_user_weapon(iAttacker) == CSW_SG550)
	{
		if(g_has_vsk94[iAttacker])
			set_msg_arg_string(4, "sg550")
		else if(g_has_sl8[iAttacker])
			set_msg_arg_string(4, "sg550")
	}
	return PLUGIN_CONTINUE
}

stock fm_cs_get_current_weapon_ent(id)
{
	return get_pdata_cbase(id, OFFSET_ACTIVE_ITEM, OFFSET_LINUX)
}

stock fm_cs_get_weapon_ent_owner(ent)
{
	return get_pdata_cbase(ent, OFFSET_WEAPONOWNER, OFFSET_LINUX_WEAPONS)
}

stock UTIL_PlayWeaponAnimation(const Player, const Sequence)
{
	set_pev(Player, pev_weaponanim, Sequence)
	
	message_begin(MSG_ONE_UNRELIABLE, SVC_WEAPONANIM, .player = Player)
	write_byte(Sequence)
	write_byte(pev(Player, pev_body))
	message_end()
}

public m24_ItemPostFrame(weapon_entity) 
{
     new id = pev(weapon_entity, pev_owner)
     if (!is_user_connected(id))
          return HAM_IGNORED

     if (!g_has_m24[id])
          return HAM_IGNORED

     static iClipExtra
     
     iClipExtra = get_pcvar_num(cvar_clip_m24)
     new Float:flNextAttack = get_pdata_float(id, m_flNextAttack, PLAYER_LINUX_XTRA_OFF)

     new iBpAmmo = cs_get_user_bpammo(id, CSW_SCOUT)
     new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)

     new fInReload = get_pdata_int(weapon_entity, m_fInReload, WEAP_LINUX_XTRA_OFF) 

     if( fInReload && flNextAttack <= 0.0 )
     {
	     new j = min(iClipExtra - iClip, iBpAmmo)
	
	     set_pdata_int(weapon_entity, m_iClip, iClip + j, WEAP_LINUX_XTRA_OFF)
	     cs_set_user_bpammo(id, CSW_SCOUT, iBpAmmo-j)
		
	     set_pdata_int(weapon_entity, m_fInReload, 0, WEAP_LINUX_XTRA_OFF)
	     fInReload = 0
     }
     return HAM_IGNORED
}

public awpcamo_ItemPostFrame(weapon_entity) 
{
     new id = pev(weapon_entity, pev_owner)
     if (!is_user_connected(id))
          return HAM_IGNORED

     if (!g_has_awpcamo[id])
          return HAM_IGNORED

     static iClipExtra
     
     iClipExtra = get_pcvar_num(cvar_clip_awpcamo)
     new Float:flNextAttack = get_pdata_float(id, m_flNextAttack, PLAYER_LINUX_XTRA_OFF)

     new iBpAmmo = cs_get_user_bpammo(id, CSW_AWP)
     new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)

     new fInReload = get_pdata_int(weapon_entity, m_fInReload, WEAP_LINUX_XTRA_OFF) 

     if( fInReload && flNextAttack <= 0.0 )
     {
	     new j = min(iClipExtra - iClip, iBpAmmo)
	
	     set_pdata_int(weapon_entity, m_iClip, iClip + j, WEAP_LINUX_XTRA_OFF)
	     cs_set_user_bpammo(id, CSW_AWP, iBpAmmo-j)
		
	     set_pdata_int(weapon_entity, m_fInReload, 0, WEAP_LINUX_XTRA_OFF)
	     fInReload = 0
     }
     return HAM_IGNORED
}

public m200_ItemPostFrame(weapon_entity) 
{
     new id = pev(weapon_entity, pev_owner)
     if (!is_user_connected(id))
          return HAM_IGNORED

     if (!g_has_m200[id])
          return HAM_IGNORED

     static iClipExtra
     
     iClipExtra = get_pcvar_num(cvar_clip_m200)
     new Float:flNextAttack = get_pdata_float(id, m_flNextAttack, PLAYER_LINUX_XTRA_OFF)

     new iBpAmmo = cs_get_user_bpammo(id, CSW_AWP)
     new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)

     new fInReload = get_pdata_int(weapon_entity, m_fInReload, WEAP_LINUX_XTRA_OFF) 

     if( fInReload && flNextAttack <= 0.0 )
     {
	     new j = min(iClipExtra - iClip, iBpAmmo)
	
	     set_pdata_int(weapon_entity, m_iClip, iClip + j, WEAP_LINUX_XTRA_OFF)
	     cs_set_user_bpammo(id, CSW_AWP, iBpAmmo-j)
		
	     set_pdata_int(weapon_entity, m_fInReload, 0, WEAP_LINUX_XTRA_OFF)
	     fInReload = 0
     }
     return HAM_IGNORED
}

public trg42_ItemPostFrame(weapon_entity) 
{
     new id = pev(weapon_entity, pev_owner)
     if (!is_user_connected(id))
          return HAM_IGNORED

     if (!g_has_trg42[id])
          return HAM_IGNORED

     static iClipExtra
     
     iClipExtra = get_pcvar_num(cvar_clip_trg42)
     new Float:flNextAttack = get_pdata_float(id, m_flNextAttack, PLAYER_LINUX_XTRA_OFF)

     new iBpAmmo = cs_get_user_bpammo(id, CSW_AWP)
     new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)

     new fInReload = get_pdata_int(weapon_entity, m_fInReload, WEAP_LINUX_XTRA_OFF) 

     if( fInReload && flNextAttack <= 0.0 )
     {
	     new j = min(iClipExtra - iClip, iBpAmmo)
	
	     set_pdata_int(weapon_entity, m_iClip, iClip + j, WEAP_LINUX_XTRA_OFF)
	     cs_set_user_bpammo(id, CSW_AWP, iBpAmmo-j)
		
	     set_pdata_int(weapon_entity, m_fInReload, 0, WEAP_LINUX_XTRA_OFF)
	     fInReload = 0
     }
     return HAM_IGNORED
}

public svd_ItemPostFrame(weapon_entity) 
{
     new id = pev(weapon_entity, pev_owner)
     if (!is_user_connected(id))
          return HAM_IGNORED

     if (!g_has_svd[id])
          return HAM_IGNORED

     static iClipExtra
     
     iClipExtra = get_pcvar_num(cvar_clip_svd)
     new Float:flNextAttack = get_pdata_float(id, m_flNextAttack, PLAYER_LINUX_XTRA_OFF)

     new iBpAmmo = cs_get_user_bpammo(id, CSW_G3SG1)
     new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)

     new fInReload = get_pdata_int(weapon_entity, m_fInReload, WEAP_LINUX_XTRA_OFF) 

     if( fInReload && flNextAttack <= 0.0 )
     {
	     new j = min(iClipExtra - iClip, iBpAmmo)
	
	     set_pdata_int(weapon_entity, m_iClip, iClip + j, WEAP_LINUX_XTRA_OFF)
	     cs_set_user_bpammo(id, CSW_G3SG1, iBpAmmo-j)
		
	     set_pdata_int(weapon_entity, m_fInReload, 0, WEAP_LINUX_XTRA_OFF)
	     fInReload = 0
     }
     return HAM_IGNORED
}

public vsk94_ItemPostFrame(weapon_entity) 
{
     new id = pev(weapon_entity, pev_owner)
     if (!is_user_connected(id))
          return HAM_IGNORED

     if (!g_has_vsk94[id])
          return HAM_IGNORED

     static iClipExtra
     
     iClipExtra = get_pcvar_num(cvar_clip_vsk94)
     new Float:flNextAttack = get_pdata_float(id, m_flNextAttack, PLAYER_LINUX_XTRA_OFF)

     new iBpAmmo = cs_get_user_bpammo(id, CSW_SG550)
     new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)

     new fInReload = get_pdata_int(weapon_entity, m_fInReload, WEAP_LINUX_XTRA_OFF) 

     if( fInReload && flNextAttack <= 0.0 )
     {
	     new j = min(iClipExtra - iClip, iBpAmmo)
	
	     set_pdata_int(weapon_entity, m_iClip, iClip + j, WEAP_LINUX_XTRA_OFF)
	     cs_set_user_bpammo(id, CSW_SG550, iBpAmmo-j)
		
	     set_pdata_int(weapon_entity, m_fInReload, 0, WEAP_LINUX_XTRA_OFF)
	     fInReload = 0
     }
     return HAM_IGNORED
}

public sl8_ItemPostFrame(weapon_entity) 
{
     new id = pev(weapon_entity, pev_owner)
     if (!is_user_connected(id))
          return HAM_IGNORED

     if (!g_has_sl8[id])
          return HAM_IGNORED

     static iClipExtra
     
     iClipExtra = get_pcvar_num(cvar_clip_sl8)
     new Float:flNextAttack = get_pdata_float(id, m_flNextAttack, PLAYER_LINUX_XTRA_OFF)

     new iBpAmmo = cs_get_user_bpammo(id, CSW_SG550)
     new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)

     new fInReload = get_pdata_int(weapon_entity, m_fInReload, WEAP_LINUX_XTRA_OFF) 

     if( fInReload && flNextAttack <= 0.0 )
     {
	     new j = min(iClipExtra - iClip, iBpAmmo)
	
	     set_pdata_int(weapon_entity, m_iClip, iClip + j, WEAP_LINUX_XTRA_OFF)
	     cs_set_user_bpammo(id, CSW_SG550, iBpAmmo-j)
		
	     set_pdata_int(weapon_entity, m_fInReload, 0, WEAP_LINUX_XTRA_OFF)
	     fInReload = 0
     }
     return HAM_IGNORED
}

public m24_Reload(weapon_entity) 
{
     new id = pev(weapon_entity, pev_owner)
     if (!is_user_connected(id))
          return HAM_IGNORED

     if (!g_has_m24[id])
          return HAM_IGNORED

     static iClipExtra

     if(g_has_m24[id])
          iClipExtra = get_pcvar_num(cvar_clip_m24)

     g_m24_TmpClip[id] = -1

     new iBpAmmo = cs_get_user_bpammo(id, CSW_SCOUT)
     new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)

     if (iBpAmmo <= 0)
          return HAM_SUPERCEDE

     if (iClip >= iClipExtra)
          return HAM_SUPERCEDE

     g_m24_TmpClip[id] = iClip

     return HAM_IGNORED
}

public awpcamo_Reload(weapon_entity) 
{
     new id = pev(weapon_entity, pev_owner)
     if (!is_user_connected(id))
          return HAM_IGNORED

     if (!g_has_awpcamo[id])
          return HAM_IGNORED

     static iClipExtra

     if(g_has_awpcamo[id])
          iClipExtra = get_pcvar_num(cvar_clip_awpcamo)

     g_awpcamo_TmpClip[id] = -1

     new iBpAmmo = cs_get_user_bpammo(id, CSW_AWP)
     new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)

     if (iBpAmmo <= 0)
          return HAM_SUPERCEDE

     if (iClip >= iClipExtra)
          return HAM_SUPERCEDE

     g_awpcamo_TmpClip[id] = iClip

     return HAM_IGNORED
}

public m200_Reload(weapon_entity) 
{
     new id = pev(weapon_entity, pev_owner)
     if (!is_user_connected(id))
          return HAM_IGNORED

     if (!g_has_m200[id])
          return HAM_IGNORED

     static iClipExtra

     if(g_has_m200[id])
          iClipExtra = get_pcvar_num(cvar_clip_m200)

     g_m200_TmpClip[id] = -1

     new iBpAmmo = cs_get_user_bpammo(id, CSW_AWP)
     new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)

     if (iBpAmmo <= 0)
          return HAM_SUPERCEDE

     if (iClip >= iClipExtra)
          return HAM_SUPERCEDE

     g_m200_TmpClip[id] = iClip

     return HAM_IGNORED
}

public trg42_Reload(weapon_entity) 
{
     new id = pev(weapon_entity, pev_owner)
     if (!is_user_connected(id))
          return HAM_IGNORED

     if (!g_has_trg42[id])
          return HAM_IGNORED

     static iClipExtra

     if(g_has_trg42[id])
          iClipExtra = get_pcvar_num(cvar_clip_trg42)

     g_trg42_TmpClip[id] = -1

     new iBpAmmo = cs_get_user_bpammo(id, CSW_AWP)
     new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)

     if (iBpAmmo <= 0)
          return HAM_SUPERCEDE

     if (iClip >= iClipExtra)
          return HAM_SUPERCEDE

     g_trg42_TmpClip[id] = iClip

     return HAM_IGNORED
}

public svd_Reload(weapon_entity) 
{
     new id = pev(weapon_entity, pev_owner)
     if (!is_user_connected(id))
          return HAM_IGNORED

     if (!g_has_svd[id])
          return HAM_IGNORED

     static iClipExtra

     if(g_has_svd[id])
          iClipExtra = get_pcvar_num(cvar_clip_svd)

     g_svd_TmpClip[id] = -1

     new iBpAmmo = cs_get_user_bpammo(id, CSW_G3SG1)
     new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)

     if (iBpAmmo <= 0)
          return HAM_SUPERCEDE

     if (iClip >= iClipExtra)
          return HAM_SUPERCEDE

     g_svd_TmpClip[id] = iClip

     return HAM_IGNORED
}

public vsk94_Reload(weapon_entity) 
{
     new id = pev(weapon_entity, pev_owner)
     if (!is_user_connected(id))
          return HAM_IGNORED

     if (!g_has_vsk94[id])
          return HAM_IGNORED

     static iClipExtra

     if(g_has_vsk94[id])
          iClipExtra = get_pcvar_num(cvar_clip_vsk94)

     g_vsk94_TmpClip[id] = -1

     new iBpAmmo = cs_get_user_bpammo(id, CSW_SG550)
     new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)

     if (iBpAmmo <= 0)
          return HAM_SUPERCEDE

     if (iClip >= iClipExtra)
          return HAM_SUPERCEDE

     g_vsk94_TmpClip[id] = iClip

     return HAM_IGNORED
}

public sl8_Reload(weapon_entity) 
{
     new id = pev(weapon_entity, pev_owner)
     if (!is_user_connected(id))
          return HAM_IGNORED

     if (!g_has_sl8[id])
          return HAM_IGNORED

     static iClipExtra

     if(g_has_sl8[id])
          iClipExtra = get_pcvar_num(cvar_clip_sl8)

     g_sl8_TmpClip[id] = -1

     new iBpAmmo = cs_get_user_bpammo(id, CSW_SG550)
     new iClip = get_pdata_int(weapon_entity, m_iClip, WEAP_LINUX_XTRA_OFF)

     if (iBpAmmo <= 0)
          return HAM_SUPERCEDE

     if (iClip >= iClipExtra)
          return HAM_SUPERCEDE

     g_sl8_TmpClip[id] = iClip

     return HAM_IGNORED
}

public m24_Reload_Post(weapon_entity) 
{
	new id = pev(weapon_entity, pev_owner)
	if (!is_user_connected(id))
		return HAM_IGNORED

	if (!g_has_m24[id])
		return HAM_IGNORED

	if (g_m24_TmpClip[id] == -1)
		return HAM_IGNORED

	set_pdata_int(weapon_entity, m_iClip, g_m24_TmpClip[id], WEAP_LINUX_XTRA_OFF)

	set_pdata_float(weapon_entity, m_flTimeWeaponIdle, m24_RELOAD_TIME, WEAP_LINUX_XTRA_OFF)

	set_pdata_float(id, m_flNextAttack, m24_RELOAD_TIME, PLAYER_LINUX_XTRA_OFF)

	set_pdata_int(weapon_entity, m_fInReload, 1, WEAP_LINUX_XTRA_OFF)

	UTIL_PlayWeaponAnimation(id, m24_RELOAD)

	return HAM_IGNORED
}

public awpcamo_Reload_Post(weapon_entity) 
{
	new id = pev(weapon_entity, pev_owner)
	if (!is_user_connected(id))
		return HAM_IGNORED

	if (!g_has_awpcamo[id])
		return HAM_IGNORED

	if (g_awpcamo_TmpClip[id] == -1)
		return HAM_IGNORED

	set_pdata_int(weapon_entity, m_iClip, g_awpcamo_TmpClip[id], WEAP_LINUX_XTRA_OFF)

	set_pdata_float(weapon_entity, m_flTimeWeaponIdle, awpcamo_RELOAD_TIME, WEAP_LINUX_XTRA_OFF)

	set_pdata_float(id, m_flNextAttack, awpcamo_RELOAD_TIME, PLAYER_LINUX_XTRA_OFF)

	set_pdata_int(weapon_entity, m_fInReload, 1, WEAP_LINUX_XTRA_OFF)

	UTIL_PlayWeaponAnimation(id, awpcamo_RELOAD)

	return HAM_IGNORED
}

public m200_Reload_Post(weapon_entity) 
{
	new id = pev(weapon_entity, pev_owner)
	if (!is_user_connected(id))
		return HAM_IGNORED

	if (!g_has_m200[id])
		return HAM_IGNORED

	if (g_m200_TmpClip[id] == -1)
		return HAM_IGNORED

	set_pdata_int(weapon_entity, m_iClip, g_m200_TmpClip[id], WEAP_LINUX_XTRA_OFF)

	set_pdata_float(weapon_entity, m_flTimeWeaponIdle, m200_RELOAD_TIME, WEAP_LINUX_XTRA_OFF)

	set_pdata_float(id, m_flNextAttack, m200_RELOAD_TIME, PLAYER_LINUX_XTRA_OFF)

	set_pdata_int(weapon_entity, m_fInReload, 1, WEAP_LINUX_XTRA_OFF)

	UTIL_PlayWeaponAnimation(id, m200_RELOAD)

	return HAM_IGNORED
}

public trg42_Reload_Post(weapon_entity) 
{
	new id = pev(weapon_entity, pev_owner)
	if (!is_user_connected(id))
		return HAM_IGNORED

	if (!g_has_trg42[id])
		return HAM_IGNORED

	if (g_trg42_TmpClip[id] == -1)
		return HAM_IGNORED

	set_pdata_int(weapon_entity, m_iClip, g_trg42_TmpClip[id], WEAP_LINUX_XTRA_OFF)

	set_pdata_float(weapon_entity, m_flTimeWeaponIdle, trg42_RELOAD_TIME, WEAP_LINUX_XTRA_OFF)

	set_pdata_float(id, m_flNextAttack, trg42_RELOAD_TIME, PLAYER_LINUX_XTRA_OFF)

	set_pdata_int(weapon_entity, m_fInReload, 1, WEAP_LINUX_XTRA_OFF)

	UTIL_PlayWeaponAnimation(id, trg42_RELOAD)

	return HAM_IGNORED
}

public svd_Reload_Post(weapon_entity) 
{
	new id = pev(weapon_entity, pev_owner)
	if (!is_user_connected(id))
		return HAM_IGNORED

	if (!g_has_svd[id])
		return HAM_IGNORED

	if (g_svd_TmpClip[id] == -1)
		return HAM_IGNORED

	set_pdata_int(weapon_entity, m_iClip, g_svd_TmpClip[id], WEAP_LINUX_XTRA_OFF)

	set_pdata_float(weapon_entity, m_flTimeWeaponIdle, svd_RELOAD_TIME, WEAP_LINUX_XTRA_OFF)

	set_pdata_float(id, m_flNextAttack, svd_RELOAD_TIME, PLAYER_LINUX_XTRA_OFF)

	set_pdata_int(weapon_entity, m_fInReload, 1, WEAP_LINUX_XTRA_OFF)

	UTIL_PlayWeaponAnimation(id, svd_RELOAD)

	return HAM_IGNORED
}

public vsk94_Reload_Post(weapon_entity) 
{
	new id = pev(weapon_entity, pev_owner)
	if (!is_user_connected(id))
		return HAM_IGNORED

	if (!g_has_vsk94[id])
		return HAM_IGNORED

	if (g_vsk94_TmpClip[id] == -1)
		return HAM_IGNORED

	set_pdata_int(weapon_entity, m_iClip, g_vsk94_TmpClip[id], WEAP_LINUX_XTRA_OFF)

	set_pdata_float(weapon_entity, m_flTimeWeaponIdle, vsk94_RELOAD_TIME, WEAP_LINUX_XTRA_OFF)

	set_pdata_float(id, m_flNextAttack, vsk94_RELOAD_TIME, PLAYER_LINUX_XTRA_OFF)

	set_pdata_int(weapon_entity, m_fInReload, 1, WEAP_LINUX_XTRA_OFF)

	UTIL_PlayWeaponAnimation(id, vsk94_RELOAD)

	return HAM_IGNORED
}

public sl8_Reload_Post(weapon_entity) 
{
	new id = pev(weapon_entity, pev_owner)
	if (!is_user_connected(id))
		return HAM_IGNORED

	if (!g_has_sl8[id])
		return HAM_IGNORED

	if (g_sl8_TmpClip[id] == -1)
		return HAM_IGNORED

	set_pdata_int(weapon_entity, m_iClip, g_sl8_TmpClip[id], WEAP_LINUX_XTRA_OFF)

	set_pdata_float(weapon_entity, m_flTimeWeaponIdle, sl8_RELOAD_TIME, WEAP_LINUX_XTRA_OFF)

	set_pdata_float(id, m_flNextAttack, sl8_RELOAD_TIME, PLAYER_LINUX_XTRA_OFF)

	set_pdata_int(weapon_entity, m_fInReload, 1, WEAP_LINUX_XTRA_OFF)

	UTIL_PlayWeaponAnimation(id, sl8_RELOAD)

	return HAM_IGNORED
}

stock drop_weapons(id, dropwhat)
{
     static weapons[32], num, i, weaponid
     num = 0
     get_user_weapons(id, weapons, num)
     
     for (i = 0; i < num; i++)
     {
          weaponid = weapons[i]
          
          if (dropwhat == 1 && ((1<<weaponid) & PRIMARY_WEAPONS_BIT_SUM))
          {
               static wname[32]
               get_weaponname(weaponid, wname, sizeof wname - 1)
               engclient_cmd(id, "drop", wname)
          }
     }
}